// AdvDlg.cpp : implementation file
//

#include "stdafx.h"
#include "stdlib.h"
#include "stdio.h"

#include "photo.h"
#include "AdvDlg.h"
#include "procs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAdvDlg dialog


//CAdvDlg::CAdvDlg(CWnd* pParent /*=NULL*/)
//	: CDialog(CAdvDlg::IDD, pParent)
CAdvDlg::CAdvDlg(CWnd* pParent /*=NULL*/)
	: CTipsDlg(CAdvDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAdvDlg)
	m_quality = 0;
	m_prg = _T("");
	m_sound = FALSE;
	m_mask = _T("");
	m_source = -1;
	m_dpi_st = _T("");
	m_names = FALSE;
	m_cropx = 0;
	m_cropy = 0;
	m_autocrop = FALSE;
	m_reverse = FALSE;
	m_change = FALSE;
	m_minx = 0;
	m_miny = 0;
	m_ratio = FALSE;
	m_logpath = _T("");
	m_log = FALSE;
	m_split = FALSE;
	m_splitx = 0;
	m_splity = 0;
	m_tooltips = FALSE;
	m_check = FALSE;
	//}}AFX_DATA_INIT
}


void CAdvDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAdvDlg)
	DDX_Control(pDX, IDC_CHECK, m_check_cb);
	DDX_Control(pDX, IDC_AUTOCROP, m_autocrop_cb);
	DDX_Control(pDX, IDC_SPLITY, m_splity_ed);
	DDX_Control(pDX, IDC_SPLITX, m_splitx_ed);
	DDX_Control(pDX, IDC_SPLIT, m_split_cb);
	DDX_Control(pDX, IDC_LOG, m_log_cb);
	DDX_Control(pDX, IDC_LOGPATH, m_logpath_ed);
	DDX_Control(pDX, IDC_RATIO, m_ratio_cb);
	DDX_Control(pDX, IDC_PRG, m_prg_ed);
	DDX_Control(pDX, IDC_MINY, m_miny_ed);
	DDX_Control(pDX, IDC_MINX, m_minx_ed);
	DDX_Control(pDX, IDC_CHANGE, m_change_cb);
	DDX_Control(pDX, IDC_REVERSE, m_reverse_cb);
	DDX_Control(pDX, IDC_CROPY, m_cropy_ed);
	DDX_Control(pDX, IDC_CROPX, m_cropx_ed);
	DDX_Control(pDX, IDC_NAMES, m_names_cb);
	DDX_Control(pDX, IDC_DPI, m_dpi_cb);
	DDX_Control(pDX, IDC_MASK, m_mask_ed);
	DDX_Control(pDX, IDC_QUALITY_SL, m_quality_sl);
	DDX_Text(pDX, IDC_QUALITY, m_quality);
	DDX_Text(pDX, IDC_PRG, m_prg);
	DDX_Check(pDX, IDC_SOUND, m_sound);
	DDX_Text(pDX, IDC_MASK, m_mask);
	DDX_Radio(pDX, IDC_SOURCE1, m_source);
	DDX_CBString(pDX, IDC_DPI, m_dpi_st);
	DDX_Check(pDX, IDC_NAMES, m_names);
	DDX_Text(pDX, IDC_CROPX, m_cropx);
	DDV_MinMaxInt(pDX, m_cropx, 0, 65536);
	DDX_Text(pDX, IDC_CROPY, m_cropy);
	DDV_MinMaxInt(pDX, m_cropy, 0, 65536);
	DDX_Check(pDX, IDC_AUTOCROP, m_autocrop);
	DDX_Check(pDX, IDC_REVERSE, m_reverse);
	DDX_Check(pDX, IDC_CHANGE, m_change);
	DDX_Text(pDX, IDC_MINX, m_minx);
	DDX_Text(pDX, IDC_MINY, m_miny);
	DDX_Check(pDX, IDC_RATIO, m_ratio);
	DDX_Text(pDX, IDC_LOGPATH, m_logpath);
	DDX_Check(pDX, IDC_LOG, m_log);
	DDX_Check(pDX, IDC_SPLIT, m_split);
	DDX_Text(pDX, IDC_SPLITX, m_splitx);
	DDX_Text(pDX, IDC_SPLITY, m_splity);
	DDX_Check(pDX, IDC_TOOLTIPS, m_tooltips);
	DDX_Check(pDX, IDC_CHECK, m_check);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAdvDlg, CTipsDlg)
	//{{AFX_MSG_MAP(CAdvDlg)
	ON_WM_HSCROLL()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_SOURCE1, OnSource)
	ON_BN_CLICKED(IDC_SOURCE2, OnSource2)
	ON_EN_KILLFOCUS(IDC_MASK, OnKillfocusMask)
	ON_CBN_KILLFOCUS(IDC_DPI, OnKillfocusDpi)
	ON_BN_CLICKED(IDC_AUTOCROP, OnAutocrop)
	ON_BN_CLICKED(IDC_CHANGE, OnChange)
	ON_BN_CLICKED(IDC_LOG, OnLog)
	ON_BN_CLICKED(IDC_SPLIT, OnSplit)
	ON_BN_CLICKED(IDC_TOOLTIPS, OnTooltips)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CAdvDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	m_quality = m_quality_sl.GetPos();
	UpdateData(VAR2CTRL);
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

BOOL CAdvDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_quality_sl.ClearTics(TRUE);
	for (int i=10; i<100; i+=10)
		m_quality_sl.SetTic(i);
	m_quality_sl.SetRange(1,99,TRUE);
	m_quality_sl.SetPos(m_quality);
	m_quality_sl.SetPageSize(10);
	m_dpi_st = Str(m_dpi);
	UpdateData(VAR2CTRL);

	OnSource();
	OnAutocrop();

// TOOL TIPS
	EnableToolTips(m_tooltips);

	return TRUE;
}

void CAdvDlg::OnDestroy() 
{
	UpdateData(CTRL2VAR);
	CDialog::OnDestroy();
}

void CAdvDlg::OnSource2() {	OnSource(); }
void CAdvDlg::OnSource() 
{
	UpdateData(CTRL2VAR);
	m_mask_ed.EnableWindow(m_source == 1);
	m_names_cb.EnableWindow(m_source == 1);
	m_prg_ed.EnableWindow(m_source == 0);
	m_check_cb.EnableWindow(m_source == 0);
}

void CAdvDlg::OnKillfocusMask() 
{
	UpdateData(CTRL2VAR);
    CFileFind finder;
    BOOL bWorking = finder.FindFile(m_mask);
    int cnt = 0;
	while (bWorking)
    {  bWorking = finder.FindNextFile();
       if (!finder.IsDots() && !finder.IsDirectory()) cnt++;
    }
	MessageBox("Number of files found : "+Str(cnt),app_name,MB_ICONINFORMATION);
}

void CAdvDlg::OnKillfocusDpi() 
{
	UpdateData(CTRL2VAR);
	m_dpi = atoi(m_dpi_st);
	m_dpi_st = Str(m_dpi);
	UpdateData(VAR2CTRL);
}

void CAdvDlg::OnAutocrop() 
{
	UpdateData(CTRL2VAR);
	m_cropx_ed.EnableWindow(m_autocrop);
	m_cropy_ed.EnableWindow(m_autocrop);
	m_reverse_cb.EnableWindow(m_autocrop);
	m_ratio_cb.EnableWindow(m_autocrop);
	m_change_cb.EnableWindow(m_autocrop);
	m_minx_ed.EnableWindow(m_autocrop && m_change);
	m_miny_ed.EnableWindow(m_autocrop && m_change);
	m_log_cb.EnableWindow(m_autocrop);
	m_logpath_ed.EnableWindow(m_autocrop && m_log);
	m_split_cb.EnableWindow(!m_autocrop);
	m_splitx_ed.EnableWindow(!m_autocrop && m_split);
	m_splity_ed.EnableWindow(!m_autocrop && m_split);
	m_autocrop_cb.EnableWindow(!m_split);
}

void CAdvDlg::OnChange() 
{	OnAutocrop(); }

void CAdvDlg::OnLog() 
{	OnAutocrop(); }

void CAdvDlg::OnSplit() 
{	OnAutocrop(); }

void CAdvDlg::OnTooltips() 
{
	UpdateData(CTRL2VAR);
	EnableToolTips(m_tooltips);
}
