// photoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "photo.h"
#include "photoDlg.h"
#include "advDlg.h"
#include "procs.h"

#include "mmsystem.h"
#include "winbase.h"
#include "JpegFile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPhotoDlg dialog

CPhotoDlg::CPhotoDlg(CWnd* pParent /*=NULL*/)
	: CTipsDlg(CPhotoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPhotoDlg)
	m_path = _T("");
	m_offset = 0;
	m_status = _T("");
	m_height = _T("");
	m_width = _T("");
	m_auto = FALSE;
	m_stretch = FALSE;
	m_boxh = _T("");
	m_boxw = _T("");
	m_depth = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPhotoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPhotoDlg)
	DDX_Control(pDX, IDC_LOAD, m_load);
	DDX_Control(pDX, IDC_OFFSET, m_offset_ed);
	DDX_Control(pDX, IDC_OFFSET_SP, m_offset_sp);
	DDX_Control(pDX, IDC_DETAIL2, m_detail2);
	DDX_Control(pDX, IDC_DETAIL4, m_detail4);
	DDX_Control(pDX, IDC_DETAIL3, m_detail3);
	DDX_Control(pDX, IDC_DETAIL1, m_detail1);
	DDX_Control(pDX, IDC_LAUNCH, m_launch);
	DDX_Control(pDX, IDC_SAVE, m_save);
	DDX_Control(pDX, IDC_DLGIMAGE, m_dlgimage);
	DDX_Control(pDX, IDC_EMPTY, m_empty);
	DDX_Control(pDX, IDC_PASTE, m_paste);
	DDX_Text(pDX, IDC_PATH, m_path);
	DDX_Text(pDX, IDC_OFFSET, m_offset);
	DDV_MinMaxInt(pDX, m_offset, 0, 99);
	DDX_Text(pDX, IDC_STATUS, m_status);
	DDX_Text(pDX, IDC_HEIGHT, m_height);
	DDX_Text(pDX, IDC_WIDTH, m_width);
	DDX_Check(pDX, IDC_AUTO, m_auto);
	DDX_Check(pDX, IDC_STRETCH, m_stretch);
	DDX_Text(pDX, IDC_BOXH, m_boxh);
	DDX_Text(pDX, IDC_BOXW, m_boxw);
	DDX_Text(pDX, IDC_DEPTH, m_depth);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPhotoDlg, CTipsDlg)
	//{{AFX_MSG_MAP(CPhotoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PASTE, OnPaste)
	ON_BN_CLICKED(IDC_EMPTY, OnEmpty)
	ON_WM_DRAWCLIPBOARD()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	ON_BN_CLICKED(IDC_LAUNCH, OnLaunch)
	ON_BN_CLICKED(IDC_AUTO, OnAuto)
	ON_BN_CLICKED(IDC_STRETCH, OnStretch)
	ON_EN_CHANGE(IDC_PATH, OnChangePath)
	ON_EN_CHANGE(IDC_OFFSET, OnChangeOffset)
	ON_EN_CHANGE(IDC_PRG, OnChangePrg)
	ON_BN_CLICKED(IDC_ADVANCED, OnAdvanced)
	ON_NOTIFY(UDN_DELTAPOS, IDC_OFFSET_SP, OnDeltaposOffsetSp)
	ON_BN_CLICKED(IDC_LOAD, OnLoad)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// SYSTEM FUNCTIONS

BOOL CPhotoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
		pSysMenu->DeleteMenu(SC_MAXIMIZE, MF_BYCOMMAND);
		pSysMenu->DeleteMenu(SC_SIZE, MF_BYCOMMAND);
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// DATA
	SndReady = LoadWAV(IDR_READY);
	m_imagewidth = 0;
	m_imageheight = 0;
	m_source = 0;
	m_grayscale = false;
	m_imagebuf = NULL;

	// SEPARATE BITMAP HEADER & GRAY PALETTE
	bmi_image = (LPBITMAPINFO)GlobalAlloc(GMEM_FIXED,sizeof(BITMAPINFOHEADER)+4*256);
	RGBQUAD quad;
	quad.rgbReserved=0;
	quad.rgbBlue=0;
	for (int i=0;i<256;i++) {
		quad.rgbBlue=i;
		quad.rgbGreen=i;
		quad.rgbRed=i;
		bmi_image->bmiColors[i]=quad;
	}

	// CONFIGURATION
	m_path = GetRegStr("Path","C:\\IMAGES\\");
	m_prg = GetRegStr("Prg","C:\\WINDOWS\\TWAIN_32\\KYE32\\KYE32.EXE");
	m_auto = GetRegInt("Auto",0);
	m_stretch = GetRegInt("Stretch",1);
	m_sound = GetRegInt("Sound",0);
	m_quality = GetRegInt("Quality",85);
	m_source = GetRegInt("Source",0);
	m_mask = GetRegStr("Mask","C:\\IMAGES\\*.jpg");
	m_dpi = GetRegInt("Dpi",300);
	m_names = GetRegInt("Names",1);
	m_autocrop = GetRegInt("Autocrop",0);
	m_cropx = GetRegInt("Cropx",800);
	m_cropy = GetRegInt("Cropy",600);
	m_reverse = GetRegInt("Reverse",1);
	m_change = GetRegInt("Change",0);
	m_minx = GetRegInt("Minx",0);
	m_miny = GetRegInt("Miny",0);
	m_ratio = GetRegInt("Ratio",1);
	m_log = GetRegInt("Log",0);
	m_logpath = GetRegStr("Logpath","C:\\IMAGES\\process.log");
	m_split = GetRegInt("Split",0);
	m_splitx = GetRegInt("Splitx",0);
	m_splity = GetRegInt("Splity",0);
	m_tooltips = GetRegInt("Tooltips",1);
	m_check = GetRegInt("Check",1);
	m_offset = 1;
	drag = false;
	crop = false;
	crop_done = false;
	loading = false;
	m_splitting = false;
	UpdateData(VAR2CTRL);
	UpdateControls();

	// DRAWING BUFFERS
	GetImageRect(&m_imagearea);
	CClientDC dc(this);

	dc_buffer.CreateCompatibleDC(&dc);
	dc_buffer.SetStretchBltMode(COLORONCOLOR);
	m_imagebitmap.CreateCompatibleBitmap(&dc, m_imagearea.Width(), m_imagearea.Height());
	pOldBitmap = dc_buffer.SelectObject(&m_imagebitmap);

	crop_buffer.CreateCompatibleDC(&dc);
	crop_buffer.SetStretchBltMode(COLORONCOLOR);
	crop_bitmap.CreateCompatibleBitmap(&dc, m_imagearea.Width(), m_imagearea.Height());
	crop_pOldBitmap = crop_buffer.SelectObject(&crop_bitmap);

	// CLIPBOARD
	dcb_called = false;
	clip_chain = SetClipboardViewer();
	if (!dcb_called)
		MessageBox("Clipboard tracking unavailable",app_name,MB_ICONEXCLAMATION);

	// CONTROLS
	m_launch.SetFocus();
	EnableToolTips(m_tooltips);
	return FALSE;  // return TRUE unless you set the focus to a control
}

void CPhotoDlg::OnDestroy() 
{
	ChangeClipboardChain(clip_chain);
	SetRegStr("Path",m_path);
	SetRegStr("Prg",m_prg);
	SetRegInt("Auto",m_auto);
	SetRegInt("Stretch",m_stretch);
	SetRegInt("Sound",m_sound);
	SetRegInt("Quality",m_quality);
	SetRegStr("Mask",m_mask);
	SetRegInt("Source",m_source);
	SetRegInt("Dpi",m_dpi);
	SetRegInt("Names",m_names);
	SetRegInt("Autocrop",m_autocrop);
	SetRegInt("Cropx",m_cropx);
	SetRegInt("Cropy",m_cropy);
	SetRegInt("Reverse",m_reverse);
	SetRegInt("Change",m_change);
	SetRegInt("Miny",m_miny);
	SetRegInt("Minx",m_minx);
	SetRegInt("Ratio",m_ratio);
	SetRegInt("Log",m_log);
	SetRegStr("Logpath",m_logpath);
	SetRegInt("Split",m_split);
	SetRegInt("Splitx",m_splitx);
	SetRegInt("Splity",m_splity);
	SetRegInt("Tooltips",m_tooltips);
	SetRegInt("Check",m_check);
	dc_buffer.SelectObject(pOldBitmap);
	dc_buffer.DeleteDC();
	crop_buffer.SelectObject(crop_pOldBitmap);
	crop_buffer.DeleteDC();
	GlobalFree(bmi_image);
	CDialog::OnDestroy();
}

void CPhotoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

HCURSOR CPhotoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/////////////////////////////////////////////////////////////////////////////
// GRAPHIC FUNCTIONS

void CPhotoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		PaintImage();
		CDialog::OnPaint();
	}
}

void CPhotoDlg::ProcessImage()
{
	if (m_auto) {
		OnEmpty();
		if (m_split && (m_splitx>0) && (m_splity>0)) {
			int sizex = m_imagewidth/m_splitx;
			int sizey = m_imageheight/m_splity;
			m_splitting = true;
			for (m_splitj=0; m_splitj<m_splity; m_splitj++) {
			for (m_spliti=0; m_spliti<m_splitx; m_spliti++) {
				frame.SetRect(m_spliti*sizex, m_splitj*sizey,
					(m_spliti+1)*sizex, (m_splitj+1)*sizey);
				OnSave();
			}}
			m_splitting = false;
		}
		else {
			if (m_autocrop && !crop_done) OnCrop();
			if (!m_autocrop || crop_done) {
				OnSave();
				crop_done = false;
				if (loading) OnLoad();
			}
		}
	}
}

void CPhotoDlg::PutDIBits(CDC *context, CRect rect, int x, int y, int width, int height)
{
	StretchDIBits(context->m_hDC,
				rect.TopLeft().x,
				rect.TopLeft().y,
				rect.Width(),
				rect.Height(),
				x,y,width,height,
				m_imagebuf,
				bmi_image,
				DIB_RGB_COLORS,
				SRCCOPY);
}

void CPhotoDlg::PaintImage()
{
	if (m_imagebuf!=NULL) {

	paint_dc = new CPaintDC(this);

	if (paint_dc!=NULL) {
		CRect d1Rect,d2Rect,d3Rect,d4Rect;
		GetItemRect(&m_detail1,&d1Rect);
		GetItemRect(&m_detail2,&d2Rect);
		GetItemRect(&m_detail3,&d3Rect);
		GetItemRect(&m_detail4,&d4Rect);

		if (m_stretch) {
			if (crop) {
				crop_buffer.BitBlt(0, 0, m_imagearea.Width(), m_imagearea.Height(), &dc_buffer, 0, 0, SRCCOPY);
				CBrush white(RGB(255, 255, 255));
				crop_buffer.FrameRect(m_framearea, &white);
				paint_dc->BitBlt(m_imagearea.TopLeft().x, m_imagearea.TopLeft().y,
					m_imagearea.Width(), m_imagearea.Height(), &crop_buffer, 0, 0, SRCCOPY);
			}
			else
				paint_dc->BitBlt(m_imagearea.TopLeft().x, m_imagearea.TopLeft().y,
					m_imagearea.Width(), m_imagearea.Height(), &dc_buffer, 0, 0, SRCCOPY);
		}
		else 
			PutDIBits(paint_dc, m_imagearea, -m_imageofs.x, m_imageheight-m_imagearea.Height()+m_imageofs.y,
				m_imagearea.Width(), m_imagearea.Height());

		PutDIBits(paint_dc, d1Rect, 0, m_imageheight-d1Rect.Height(),
					d1Rect.Width(), d1Rect.Height());
		PutDIBits(paint_dc, d2Rect, m_imagewidth-d2Rect.Width(), m_imageheight-d2Rect.Height(),
					d2Rect.Width(),	d2Rect.Height());
		PutDIBits(paint_dc, d3Rect, 0, 0,
					d3Rect.Width(),	d3Rect.Height());
		PutDIBits(paint_dc, d4Rect, m_imagewidth-d2Rect.Width(), 0,
					d4Rect.Width(),	d4Rect.Height());
	}
	delete paint_dc;
	}
}

void CPhotoDlg::UpdateImage()
{
	if (!m_imagebuf) return;
	if (m_imageheight == 1025) m_imageheight = 1024;
	m_imageofs.x = 0; m_imageofs.y = 0;

	bmi_image->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	bmi_image->bmiHeader.biWidth = m_imagewidth;
	bmi_image->bmiHeader.biHeight = m_imageheight;
	bmi_image->bmiHeader.biPlanes = 1;
	bmi_image->bmiHeader.biCompression = BI_RGB;
	bmi_image->bmiHeader.biSizeImage = 0;
	bmi_image->bmiHeader.biXPelsPerMeter = 0;
	bmi_image->bmiHeader.biYPelsPerMeter = 0;
	bmi_image->bmiHeader.biClrImportant = 0;
	
	if (m_grayscale) {
		bmi_image->bmiHeader.biBitCount = 8;
		bmi_image->bmiHeader.biClrUsed = 256;
	}
	else {
		bmi_image->bmiHeader.biBitCount = 24;
		bmi_image->bmiHeader.biClrUsed = 0;
	}

	if (m_stretch) {
		m_destarea = m_imagearea;
		if (m_imageheight*m_destarea.Width() > m_imagewidth*m_destarea.Height()) {
			int tx = m_destarea.Width() - (m_imagewidth*m_destarea.Height()/m_imageheight);
			m_destarea.DeflateRect(tx/2, 0);
		}
		else {
			int ty = m_destarea.Height() - (m_imageheight*m_destarea.Width()/m_imagewidth);
			m_destarea.DeflateRect(0, ty/2);
		}
		CBrush solid;
		solid.CreateSolidBrush(RGB(192, 192 ,192));
		CRect tmp = m_imagearea - m_imagearea.TopLeft();
		dc_buffer.FillRect(&tmp, &solid);
		PutDIBits(&dc_buffer, m_destarea - m_imagearea.TopLeft(), 0, 0, m_imagewidth, m_imageheight);
	}
	RedrawWindow(m_imagearea);

	CRect areaRect;
	GetItemRect(&m_detail1,&areaRect); RedrawWindow(areaRect);
	GetItemRect(&m_detail2,&areaRect); RedrawWindow(areaRect);
	GetItemRect(&m_detail3,&areaRect); RedrawWindow(areaRect);
	GetItemRect(&m_detail4,&areaRect); RedrawWindow(areaRect);

	UpdateControls();
	m_width = Str(m_imagewidth);
	m_height = Str(m_imageheight);
	if (m_grayscale) m_depth = "8-bit";
	else m_depth = "24-bit";
	UpdateData(VAR2CTRL);
}

void CPhotoDlg::GetItemRect(CWnd *wnd, CRect *areaRect)
{
	wnd->GetWindowRect(*areaRect);
	this->ScreenToClient(*areaRect);
}

void CPhotoDlg::GetImageRect(CRect *areaRect)
{
	GetItemRect(&m_dlgimage,areaRect);
}

void CPhotoDlg::SetFrame(CRect rect, BOOL nomove)
{
	rect.NormalizeRect();
	frame = rect;
	if (frame.Width() > m_imagewidth)
		frame.DeflateRect(0, 0, frame.Width()-m_imagewidth, 0);
	if (frame.Height() > m_imageheight)
		frame.DeflateRect(0, 0, 0, frame.Height()-m_imageheight);
	if (m_change) {
		int mx = m_minx; int my = m_miny;
		int cx = m_cropx; int cy = m_cropy;
		if (m_reverse && (m_imageheight > m_imagewidth)) {
			mx = m_miny; my = m_minx;
			cx = m_cropy; cy = m_cropx;
		}
		if (cx > m_imagewidth) cx = m_imagewidth;
		if (cy > m_imageheight) cy = m_imageheight;
		if (mx > m_imagewidth) mx = m_imagewidth;
		if (my > m_imageheight) mx = m_imageheight;
		if (mx > cx) mx = cx;
		if (my > cy) mx = cy;
		if (frame.Width() < mx) {
			int tx = mx - frame.Width();
			frame.InflateRect(0, 0, tx, 0);
			nomove = false;
		}
		if (frame.Height() < my) {
			int ty = my - frame.Height();
			frame.InflateRect(0, 0, 0, ty);
			nomove = false;
		}
		if (m_ratio) {
			if (cx*(frame.Height()+1) < cy*frame.Width()) {
				int tx = frame.Width() - (cx*frame.Height()/cy);
				frame.DeflateRect(0, 0, tx, 0);
				nomove = false;
			}
			if (cx*frame.Height() > cy*(frame.Width()+1)) {
				int ty = frame.Height() - (cy*frame.Width()/cx);
				frame.DeflateRect(0, 0, 0, ty);
				nomove = false;
			}
		}
	}
	if (frame.TopLeft().x < 0)
		if (nomove) frame.TopLeft().x = 0;
		else frame.OffsetRect(-frame.TopLeft().x, 0);
	if (frame.TopLeft().y < 0)
		if (nomove) frame.TopLeft().y = 0;
		else frame.OffsetRect(0, -frame.TopLeft().y);
	if (frame.BottomRight().x > m_imagewidth)
		if (nomove) frame.BottomRight().x = m_imagewidth;
		else frame.OffsetRect(m_imagewidth - frame.BottomRight().x, 0);
	if (frame.BottomRight().y > m_imageheight)
		if (nomove) frame.BottomRight().y = m_imageheight;
		else frame.OffsetRect(0, m_imageheight - frame.BottomRight().y);
	m_framearea = CRect(ImageToClient(frame.TopLeft()),
		ImageToClient(frame.BottomRight()));
	m_boxw = Str(frame.Width());
	m_boxh = Str(frame.Height());
	UpdateData(VAR2CTRL);
}

CPoint CPhotoDlg::ClientToImage(CPoint point)
{
	CPoint tmp = point;
	tmp.x = (tmp.x-m_destarea.TopLeft().x+m_imagearea.TopLeft().x)*m_imagewidth/m_destarea.Width();
	tmp.y = (tmp.y-m_destarea.TopLeft().y+m_imagearea.TopLeft().y)*m_imageheight/m_destarea.Height();
	return tmp;
}

CPoint CPhotoDlg::ImageToClient(CPoint point)
{
	CPoint tmp = point;
	tmp.x = tmp.x*m_destarea.Width()/m_imagewidth+m_destarea.TopLeft().x-m_imagearea.TopLeft().x;
	tmp.y = tmp.y*m_destarea.Height()/m_imageheight+m_destarea.TopLeft().y-m_imagearea.TopLeft().y;
	return tmp;
}

/////////////////////////////////////////////////////////////////////////////
// BUTTONS

void CPhotoDlg::OnPaste() 
{
	if (OpenClipboard()) {
		Status("Pasting ..");
		HBITMAP data = (HBITMAP)GetClipboardData(CF_BITMAP);
		HGLOBAL hDIB = (HGLOBAL)GetClipboardData(CF_DIB);
		CloseClipboard();
		BITMAPINFOHEADER header;
		if (data) {
/*			BITMAP info; CBitmap m_clipimage;
			m_clipimage.Detach(); m_clipimage.Attach(data);
			m_clipimage.GetBitmap(&info);
*/

			BYTE* lp = (BYTE*)GlobalLock(hDIB);
			memcpy(&header, lp, sizeof(BITMAPINFOHEADER));
			GlobalUnlock(hDIB);

			m_grayscale = (header.biBitCount == 8);

			if ((!m_check || 
				(header.biBitCount == 24) || (header.biBitCount == 8))
				&& (header.biPlanes == 1)) {
				m_imagewidth = header.biWidth;
				if (m_grayscale) {
					m_imagewidthDW = JpegFile::roundup1(m_imagewidth);
				}
				else {
					m_imagewidthDW = JpegFile::roundup3(m_imagewidth);
				}
				m_imageheight = header.biHeight;
				DWORD dwLen = GlobalSize(hDIB);
				if (m_imagebuf) GlobalFree(m_imagebuf);
				m_imagebuf = (BYTE*)GlobalAlloc(GMEM_FIXED,dwLen);
				if (m_imagebuf != NULL)
				{
					BYTE* lp = (BYTE*)GlobalLock(hDIB);
					int offset = sizeof(BITMAPINFOHEADER) + 4*header.biClrUsed;
					memcpy(m_imagebuf, lp + offset, dwLen - offset);
					GlobalUnlock(hDIB);
				}
				UpdateImage();
			}
			else {
				CString InfoStr = "Unsupported bitmap type:";
				InfoStr+="\n biSize="+Str(header.biSize);
				InfoStr+="\n biWidth="+Str(header.biWidth);
				InfoStr+=	"\n biHeight="+Str(header.biHeight);
				InfoStr+="\n biPlanes="+Str(header.biPlanes);
				InfoStr+="\n biBitCount="+Str(header.biBitCount);
				InfoStr+="\n biCompression="+Str(header.biCompression);
				InfoStr+="\n biSizeImage="+Str(header.biSizeImage);
				InfoStr+="\n biXPelsPerMeter="+Str(header.biXPelsPerMeter);
				InfoStr+="\n biYPelsPerMeter="+Str(header.biYPelsPerMeter);
				InfoStr+="\n biClrUsed="+Str(header.biClrUsed);
				InfoStr+="\n biClrImportant="+Str(header.biClrImportant);
				MessageBox(InfoStr,app_name,MB_ICONSTOP);
			}
		}
		else {
			MessageBox("No bitmap in clipboard",app_name,MB_ICONSTOP);
		}
		Status("");
	}
	return;
}

void CPhotoDlg::OnEmpty() 
{
	Status("Emptying clipboard ..");
	OpenClipboard();
	EmptyClipboard();
	CloseClipboard();
	Status("");
}

void CPhotoDlg::OnSave() 
{
if (m_imagebuf) {
	Status("Saving ..");
	CreateDirectory(m_path, NULL);
	UpdateData(CTRL2VAR);
	CString filename;
	if (m_names && (m_source == 1)) {
		filename = m_imagename;
	}
	else {
		filename.Format("%02d", m_offset);
		m_offset++;
	}
	if (m_splitting) {
		CString split_str;
		split_str.Format("%02d%02d",m_splitj,m_spliti);
		filename += split_str;
	}
	filename += ".jpg";
	filename.MakeLower();
//	JpegFile::BGRFromRGB(m_imagebuf, m_imagewidth, m_imageheight, m_imagewidthDW);
	BOOL ok;
	if (m_autocrop || m_splitting) {
		ok=JpegFile::RGBToJpegFile(m_path + filename,m_imagebuf,
			m_imagewidth,m_imageheight,
			!m_grayscale,&frame,m_quality,m_dpi);
		if (m_autocrop && m_log) {
			CStdioFile log(m_logpath,
				CFile::typeText|CFile::modeWrite|CFile::modeCreate|
				CFile::modeCreate|CFile::modeNoTruncate);
			log.SeekToEnd();
			CString tmp;
			tmp = filename+";crop;"+
				Str(frame.TopLeft().x)+";"+
				Str(frame.TopLeft().y)+";"+
				Str(frame.Width())+";"+
				Str(frame.Height());
			log.WriteString(tmp+"\n");
			log.Close();
		}
	}
	else {
		ok=JpegFile::RGBToJpegFile(m_path + filename,
			m_imagebuf,	m_imagewidth, m_imageheight,
			!m_grayscale,NULL,m_quality,m_dpi);
	}
	if (!ok) {
		MessageBox("Write Error",app_name,MB_ICONSTOP);
	}
	else {
		if (m_sound) PlayWAV(SndReady);
	}
//	JpegFile::BGRFromRGB(m_imagebuf, m_imagewidth, m_imageheight, m_imagewidthDW);
	UpdateData(VAR2CTRL);
	Status("");
}
}

void CPhotoDlg::OnAdvanced() 
{
	CAdvDlg dlg;
	dlg.m_prg = m_prg;
	dlg.m_quality = m_quality;
	dlg.m_sound = m_sound;
	dlg.m_mask = m_mask;
	dlg.m_source = m_source;
	dlg.m_dpi = m_dpi;
	dlg.m_names = m_names;
	dlg.m_autocrop = m_autocrop;
	dlg.m_cropx = m_cropx;
	dlg.m_cropy = m_cropy;
	dlg.m_reverse = m_reverse;
	dlg.m_minx = m_minx;
	dlg.m_miny = m_miny;
	dlg.m_change = m_change;
	dlg.m_ratio = m_ratio;
	dlg.m_log = m_log;
	dlg.m_logpath = m_logpath;
	dlg.m_split = m_split;
	dlg.m_splitx = m_splitx;
	dlg.m_splity = m_splity;
	dlg.m_tooltips = m_tooltips;
	dlg.m_check = m_check;
	if (dlg.DoModal()==1) {
		m_prg = dlg.m_prg;
		m_quality = dlg.m_quality;
		m_sound = dlg.m_sound;
		m_mask = dlg.m_mask;
		m_source = dlg.m_source;
		m_dpi = dlg.m_dpi;
		m_names = dlg.m_names;
		m_autocrop = dlg.m_autocrop;
		m_cropx = dlg.m_cropx;
		m_cropy = dlg.m_cropy;
		m_minx = dlg.m_minx;
		m_miny = dlg.m_miny;
		m_change = dlg.m_change;
		m_ratio = dlg.m_ratio;
		m_log = dlg.m_log;
		m_logpath = dlg.m_logpath;
		m_split = dlg.m_split;
		m_splitx = dlg.m_splitx;
		m_splity = dlg.m_splity;
		m_tooltips = dlg.m_tooltips;
		m_check = dlg.m_check;
	}
	UpdateControls();
	EnableToolTips(m_tooltips);
}

void CPhotoDlg::OnLaunch() 
{
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	memset(&si, 0, sizeof(si));
	si.cb = sizeof(si);
	CreateProcess(NULL, m_prg.GetBuffer(256), NULL, NULL, false,
		DETACHED_PROCESS, NULL, NULL, &si, &pi); 
}

void CPhotoDlg::OnLoad() 
{
	bool color;
	if (!loading) load_working = finder.FindFile(m_mask);
	loading = true;
	while (load_working && !crop)
    {
		Status("Loading ..");
        load_working = finder.FindNextFile();
		m_imagename = finder.GetFileTitle();
		if (m_imagebuf) GlobalFree(m_imagebuf);
		m_imagebuf = JpegFile::JpegFileToRGB(finder.GetFilePath(),
			&m_imagewidth, &m_imageheight, &color);
		m_grayscale = !color;
		if (m_grayscale) {
			m_imagewidthDW = JpegFile::roundup1(m_imagewidth);
		}
		else {
			m_imagewidthDW = JpegFile::roundup3(m_imagewidth);
			JpegFile::BGRFromRGB(m_imagebuf, m_imagewidth, m_imageheight, m_imagewidthDW);
		}
		UpdateImage();
		CString tmp = m_imagename + " - ";
		tmp += app_name;
		this->SetWindowText(tmp);
		Status("");
		ProcessImage();
    }
	if (!load_working) {
		loading = false;
		this->SetWindowText(app_name);
	}
}

/////////////////////////////////////////////////////////////////////////////
// EXTERNAL MESSAGE HANDLERS

void CPhotoDlg::OnDrawClipboard()
{
	if (m_source == 0) {
		OpenClipboard();
		cb_avail = IsClipboardFormatAvailable(CF_BITMAP);
		CloseClipboard();
		UpdateControls();
		if (cb_avail) {
			OnPaste();
			ProcessImage();
		}
		if (clip_chain && dcb_called) {
		    CWnd chain_wnd;
		chain_wnd.Attach(clip_chain);
		    chain_wnd.PostMessage(WM_DRAWCLIPBOARD, NULL, NULL);
		}
	}
	dcb_called = true;
}

/////////////////////////////////////////////////////////////////////////////
// CONTROLS

void CPhotoDlg::OnDeltaposOffsetSp(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	if (pNMUpDown->iDelta>0) {
		if (m_offset > 1) m_offset --;
	}
	else {
		if (m_offset < 99) m_offset ++;
	}
	UpdateData(VAR2CTRL);
	*pResult = 0;
}

void CPhotoDlg::Status(CString text) {
	m_status = text;
	UpdateData(VAR2CTRL);
}

void CPhotoDlg::OnAuto() 
{	UpdateData(CTRL2VAR);	}
void CPhotoDlg::OnStretch() 
{	UpdateData(CTRL2VAR); UpdateImage(); }
void CPhotoDlg::OnChangePath() 
{	UpdateData(CTRL2VAR);	}
void CPhotoDlg::OnChangeOffset() 
{	UpdateData(CTRL2VAR); m_offset_sp.SetPos(m_offset); }
void CPhotoDlg::OnChangePrg() 
{	UpdateData(CTRL2VAR);	}

void CPhotoDlg::UpdateControls()
{
	m_load.EnableWindow(m_source == 1);
	m_save.EnableWindow(m_imagebuf != NULL);
	m_paste.EnableWindow(cb_avail);
	m_empty.EnableWindow(cb_avail);
	m_offset_sp.EnableWindow(!(m_names && (m_source == 1)));
	m_offset_ed.EnableWindow(!(m_names && (m_source == 1)));
}

/////////////////////////////////////////////////////////////////////////////
// MOUSE

void CPhotoDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if (m_imagearea.PtInRect(point) && !m_stretch &&
		(m_imagewidth>m_imagearea.Width()) &&
		(m_imageheight>m_imagearea.Height())) {
		drag = true;
		drag_pt = point;
	}
	CDialog::OnLButtonDown(nFlags, point);
}

void CPhotoDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if (m_imagearea.PtInRect(point) && !m_stretch) {
		drag = false;
	}
	if (crop) {
		drag = true; crop = false;
		RedrawWindow(m_imagearea);
		drag = false;
		crop_done = true;
		m_boxw = ""; m_boxh = "";
		Status("");
		ProcessImage();
	}
	CDialog::OnLButtonUp(nFlags, point);
}

void CPhotoDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	if (!(nFlags && MK_LBUTTON)) drag = false;
	if (drag) {
		m_imageofs += (point - drag_pt);
		if (m_imageofs.x > 0) m_imageofs.x = 0;
		if (m_imageofs.y > 0) m_imageofs.y = 0;
		if (m_imageofs.x < m_imagearea.Width()-m_imagewidth) m_imageofs.x = m_imagearea.Width()-m_imagewidth;
		if (m_imageofs.y < m_imagearea.Height()-m_imageheight) m_imageofs.y = m_imagearea.Height()-m_imageheight;
		drag_pt = point;
		RedrawWindow(m_imagearea);
	}
	if (crop) {
		CRect last = frame;
		if ((nFlags && MK_CONTROL) && m_change) {
			frame.BottomRight() = ClientToImage(point - m_imagearea.TopLeft()) +
				ClientToImage(point - m_imagearea.TopLeft()) - frame.TopLeft();
			SetFrame(frame, true);
		}
		else {
			SetFrame(frame + ClientToImage(point - m_imagearea.TopLeft()) - frame.CenterPoint());
		}
		if (last != frame) RedrawWindow(m_imagearea);
	}
	CDialog::OnMouseMove(nFlags, point);
}

BOOL CPhotoDlg::OnEraseBkgnd(CDC* pDC) 
{
	if (drag || crop) return 1;
	else return CDialog::OnEraseBkgnd(pDC);
}

void CPhotoDlg::OnCrop() 
{
	int x = m_cropx;
	int y = m_cropy;
	if (x > m_imagewidth) x = m_imagewidth;
	if (y > m_imageheight) y = m_imageheight;
	if (m_reverse && (m_imageheight > m_imagewidth)) {
		x = m_cropy; y = m_cropx;
	}
	SetFrame(CRect(
		(m_imagewidth-x)/2,	(m_imageheight-y)/2,
		(m_imagewidth-x)/2+x, (m_imageheight-y)/2+y));
	if (m_stretch) {
		Status("Cropping ..");
		crop = true;
		crop_done = false;
		CPoint tmp = m_framearea.CenterPoint()+m_imagearea.TopLeft();
		ClientToScreen(&tmp);
		SetCursorPos(tmp.x, tmp.y);
		RedrawWindow(m_imagearea);
	}
	else crop_done = true;
}
